"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.badge = badge;
exports.shields = shields;
exports.npmversion = npmversion;
exports.npmdownloads = npmdownloads;
exports.daviddm = daviddm;
exports.daviddmdev = daviddmdev;
exports.nodeico = nodeico;
exports.saucelabsbm = saucelabsbm;
exports.saucelabs = saucelabs;
exports.travisci = travisci;
exports.codeship = codeship;
exports.coveralls = coveralls;
exports.codeclimate = codeclimate;
exports.bithound = bithound;
exports.waffle = waffle;
exports.sixtydevstips = sixtydevstips;
exports.githubsponsors = githubsponsors;
exports.patreon = patreon;
exports.opencollective = opencollective;
exports.gratipay = gratipay;
exports.flattr = flattr;
exports.paypal = paypal;
exports.crypto = crypto;
exports.bitcoin = bitcoin;
exports.wishlist = wishlist;
exports.buymeacoffee = buymeacoffee;
exports.liberapay = liberapay;
exports.thanksapp = thanksapp;
exports.boostlab = boostlab;
exports.slackinscript = slackinscript;
exports.slackin = slackin;
exports.gabeacon = gabeacon;
exports.googleplusone = googleplusone;
exports.redditsubmit = redditsubmit;
exports.hackernewssubmit = hackernewssubmit;
exports.facebooklike = facebooklike;
exports.facebookfollow = facebookfollow;
exports.twittertweet = twittertweet;
exports.twitterfollow = twitterfollow;
exports.githubfollow = githubfollow;
exports.githubstar = githubstar;
exports.quorafollow = quorafollow;

var _querystring = _interopRequireDefault(require("querystring"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/** Generate a HTML badge */
function badge(_ref) {
  var image = _ref.image,
      alt = _ref.alt,
      url = _ref.url,
      title = _ref.title;
  // Check
  if (!image) throw new Error('image is missing'); // Create

  var result = alt ? "<img src=\"".concat(image, "\" alt=\"").concat(alt, "\" />") : "<img src=\"".concat(image, "\" />");

  if (url) {
    result = (title ? "<a href=\"".concat(url, "\" title=\"").concat(title, "\">") : "<a href=\"".concat(url, "\">")) + result + '</a>';
  }

  return result;
}

badge.badgeCategory = 'custom';

/** Shields Custom Badge */
function shields(_ref2) {
  var left = _ref2.left,
      right = _ref2.right,
      _ref2$color = _ref2.color,
      color = _ref2$color === void 0 ? 'yellow' : _ref2$color,
      alt = _ref2.alt,
      url = _ref2.url,
      title = _ref2.title;
  // Check
  if (!left) throw new Error('left is missing');
  if (!right) throw new Error('right is missing'); // Create

  var image = "https://img.shields.io/badge/".concat(left, "-").concat(right, "-").concat(color, ".svg");
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

shields.badgeCategory = 'custom'; // ====================================
// Development Badges

/** NPM Version Badge */
function npmversion(_ref3) {
  var npmPackageName = _ref3.npmPackageName;
  // Check
  if (!npmPackageName) throw new Error('npmPackageName is missing'); // Create

  var image = "https://img.shields.io/npm/v/".concat(npmPackageName, ".svg");
  var url = "https://npmjs.org/package/".concat(npmPackageName);
  var alt = 'NPM version';
  var title = 'View this project on NPM';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

npmversion.badgeCategory = 'development';
/** NPM Downloads Badge */

function npmdownloads(_ref4) {
  var npmPackageName = _ref4.npmPackageName;
  // Check
  if (!npmPackageName) throw new Error('npmPackageName is missing');
  var image = "https://img.shields.io/npm/dm/".concat(npmPackageName, ".svg");
  var url = "https://npmjs.org/package/".concat(npmPackageName);
  var alt = 'NPM downloads';
  var title = 'View this project on NPM';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

npmdownloads.badgeCategory = 'development';
/** David DM Dependencies Badge */

function daviddm(_ref5) {
  var githubSlug = _ref5.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://img.shields.io/david/".concat(githubSlug, ".svg");
  var url = "https://david-dm.org/".concat(githubSlug);
  var alt = 'Dependency Status';
  var title = "View the status of this project's dependencies on DavidDM";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

daviddm.badgeCategory = 'development';
/** David DM Dev Dependencies Badge */

function daviddmdev(_ref6) {
  var githubSlug = _ref6.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://img.shields.io/david/dev/".concat(githubSlug, ".svg");
  var url = "https://david-dm.org/".concat(githubSlug, "#info=devDependencies");
  var alt = 'Dev Dependency Status';
  var title = "View the status of this project's development dependencies on DavidDM";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

daviddmdev.badgeCategory = 'development';

/** Nodei.co Badge */
function nodeico(_ref7) {
  var npmPackageName = _ref7.npmPackageName,
      nodeicoQueryString = _ref7.nodeicoQueryString;
  // Prepare
  if (!npmPackageName) throw new Error('npmPackageName is missing');

  if (nodeicoQueryString && typeof nodeicoQueryString !== 'string' && _typeof(nodeicoQueryString) !== 'object') {
    throw new Error('nodeicoQueryString must be a string or an object');
  } // Return


  var url = "https://www.npmjs.com/package/".concat(npmPackageName);
  var alt = 'Nodei.co badge';
  var title = 'Nodei.co badge';
  var image = "https://nodei.co/npm/".concat(npmPackageName, ".png");
  var query = _typeof(nodeicoQueryString) === 'object' ? _querystring.default.stringify(nodeicoQueryString) : nodeicoQueryString;
  if (query) image += "?".concat(query);
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

nodeico.badgeCategory = 'development'; // ====================================
// Testing Badges

/** Sauce Labs Browser Matrix Badge */
function saucelabsbm(_ref8) {
  var saucelabsUsername = _ref8.saucelabsUsername,
      saucelabsAuthToken = _ref8.saucelabsAuthToken;
  // Check
  if (!saucelabsUsername) throw new Error('saucelabsUsername is missing');
  saucelabsAuthToken = saucelabsAuthToken || process.env.SAUCELABS_AUTH_TOKEN;
  if (!saucelabsAuthToken) throw new Error('saucelabsAuthToken is missing'); // Create

  var image = "https://saucelabs.com/browser-matrix/".concat(saucelabsUsername, ".svg?auth=").concat(escape(saucelabsAuthToken));
  var url = "https://saucelabs.com/u/".concat(saucelabsUsername);
  var alt = 'Sauce Labs Browser Matrix';
  var title = "Check this project's browser tests on Sauce Labs";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

saucelabsbm.badgeCategory = 'testing';
saucelabsbm.badgeInline = false;
/** Sauce Labs Badge */

function saucelabs(_ref9) {
  var saucelabsUsername = _ref9.saucelabsUsername,
      saucelabsAuthToken = _ref9.saucelabsAuthToken;
  // Check
  if (!saucelabsUsername) throw new Error('saucelabsUsername is missing');
  saucelabsAuthToken = saucelabsAuthToken || process.env.SAUCELABS_AUTH_TOKEN;
  if (!saucelabsAuthToken) throw new Error('saucelabsAuthToken is missing'); // Create

  var image = "https://saucelabs.com/browser-matrix/".concat(saucelabsUsername, ".svg?auth=").concat(escape(saucelabsAuthToken));
  var url = "https://saucelabs.com/u/".concat(saucelabsUsername);
  var alt = 'Sauce Labs Browser Matrix';
  var title = "Check this project's browser tests on Sauce Labs";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

saucelabs.badgeCategory = 'testing';

/** Travis CI Badge */
function travisci(_ref10) {
  var githubSlug = _ref10.githubSlug,
      _ref10$travisTLD = _ref10.travisTLD,
      travisTLD = _ref10$travisTLD === void 0 ? 'org' : _ref10$travisTLD;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = ['https://img.shields.io/travis', travisTLD === 'com' ? 'com' : '', githubSlug, 'master.svg'].filter(function (i) {
    return Boolean(i);
  }).join('/');
  var url = "http://travis-ci.".concat(travisTLD, "/").concat(githubSlug);
  var alt = 'Travis CI Build Status';
  var title = "Check this project's build status on TravisCI";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

travisci.badgeCategory = 'testing';

/** Codeship Badge */
function codeship(_ref11) {
  var codeshipProjectUUID = _ref11.codeshipProjectUUID,
      codeshipProjectID = _ref11.codeshipProjectID;
  // Check
  if (!codeshipProjectUUID) throw new Error('codeshipProjectUUID is missing');
  if (!codeshipProjectID) throw new Error('codeshipProjectID is missing'); // Create

  var image = "https://img.shields.io/codeship/".concat(codeshipProjectUUID, "/master.svg");
  var url = "https://www.codeship.io/projects/".concat(codeshipProjectID);
  var alt = 'Codeship Status';
  var title = "Check this project's status on Codeship";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

codeship.badgeCategory = 'testing';
/** Coveralls Badge */

function coveralls(_ref12) {
  var githubSlug = _ref12.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://img.shields.io/coveralls/".concat(githubSlug, ".svg");
  var url = "https://coveralls.io/r/".concat(githubSlug);
  var alt = 'Coveralls Coverage Status';
  var title = "View this project's coverage on Coveralls";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

coveralls.badgeCategory = 'testing';
/** Code Climate Rating Badge */

function codeclimate(_ref13) {
  var githubSlug = _ref13.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://img.shields.io/codeclimate/github/".concat(githubSlug, ".svg");
  var url = "https://codeclimate.com/github/".concat(githubSlug);
  var alt = 'Code Climate Rating';
  var title = "View this project's rating on Code Climate";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

codeclimate.badgeCategory = 'testing';
/** BitHound Score Badge */

function bithound(_ref14) {
  var githubSlug = _ref14.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://bithound.io/github/".concat(githubSlug, "/badges/score.svg");
  var url = "https://bithound.io/github/".concat(githubSlug);
  var alt = 'BitHound Score';
  var title = "View this project's score on BitHound";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

bithound.badgeCategory = 'testing';
/** Waffle Badge */

function waffle(_ref15) {
  var githubSlug = _ref15.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var label = 'ready';
  var image = "https://badge.waffle.io/".concat(githubSlug, ".png?label=").concat(escape(label));
  var url = "http://waffle.io/".concat(githubSlug);
  var alt = 'Stories in Ready';
  var title = "View this project's stories on Waffle.io";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

waffle.badgeCategory = 'testing'; // ====================================
// Funding Badges

/** At least one of the properties must be provided */

/** 60devs Tips Badge */
function sixtydevstips(_ref16) {
  var sixtydevstipsID = _ref16.sixtydevstipsID,
      sixtydevstipsURL = _ref16.sixtydevstipsURL;

  // Check
  if (!sixtydevstipsURL) {
    if (!sixtydevstipsID) throw new Error('sixtydevstipsID is missing');
    sixtydevstipsURL = "https://tips.60devs.com/tip/".concat(sixtydevstipsID);
  } // Create


  var image = 'https://img.shields.io/badge/60devs-donate-yellow.svg';
  var url = sixtydevstipsURL;
  var alt = '60devs tips donate button';
  var title = 'Donate to this project using 60devs tips';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

sixtydevstips.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Github Sponsors Badge */
function githubsponsors(_ref17) {
  var githubSponsorsURL = _ref17.githubSponsorsURL,
      githubSponsorsUsername = _ref17.githubSponsorsUsername,
      githubUsername = _ref17.githubUsername;

  if (!githubSponsorsURL) {
    if (!githubSponsorsUsername && !githubUsername) throw new Error('githubSponsorsUsername and githubUsername are missing');
    githubSponsorsURL = "https://github.com/sponsors/".concat(githubSponsorsUsername || githubUsername);
  } // Create


  var image = 'https://img.shields.io/badge/github-donate-yellow.svg';
  var url = githubSponsorsURL;
  var alt = 'GitHub Sponsors donate button';
  var title = 'Donate to this project using GitHub Sponsors';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

githubsponsors.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Patreon Badge */
function patreon(_ref18) {
  var patreonUsername = _ref18.patreonUsername,
      patreonURL = _ref18.patreonURL;

  // Check
  if (!patreonURL) {
    if (!patreonUsername) throw new Error('patreonUsername is missing');
    patreonURL = "https://patreon.com/".concat(patreonUsername);
  } // Create


  var image = 'https://img.shields.io/badge/patreon-donate-yellow.svg';
  var url = patreonURL;
  var alt = 'Patreon donate button';
  var title = 'Donate to this project using Patreon';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

patreon.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Open Collective Badge */
function opencollective(_ref19) {
  var opencollectiveUsername = _ref19.opencollectiveUsername,
      opencollectiveURL = _ref19.opencollectiveURL;

  // Check
  if (!opencollectiveURL) {
    if (!opencollectiveUsername) throw new Error('opencollectiveUsername is missing');
    opencollectiveURL = "https://opencollective.com/".concat(opencollectiveUsername);
  } // Create


  var image = 'https://img.shields.io/badge/open%20collective-donate-yellow.svg';
  var url = opencollectiveURL;
  var alt = 'Open Collective donate button';
  var title = 'Donate to this project using Open Collective';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

opencollective.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Gratipay Badge */
function gratipay(_ref20) {
  var gratipayUsername = _ref20.gratipayUsername,
      gratipayURL = _ref20.gratipayURL;

  // Check
  if (!gratipayURL) {
    if (!gratipayUsername) throw new Error('gratipayUsername is missing');
    gratipayURL = "https://gratipay.com/".concat(gratipayUsername);
  } // Create


  var image = 'https://img.shields.io/badge/gratipay-donate-yellow.svg';
  var url = gratipayURL;
  var alt = 'Gratipay donate button';
  var title = 'Donate weekly to this project using Gratipay';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

gratipay.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Flattr Badge */
function flattr(_ref21) {
  var flattrCode = _ref21.flattrCode,
      flattrUsername = _ref21.flattrUsername,
      flattrURL = _ref21.flattrURL;

  // Check
  if (!flattrURL) {
    if (flattrUsername) {
      flattrURL = "https://flattr.com/profile/".concat(flattrUsername);
    } else if (flattrCode) {
      flattrURL = "https://flattr.com/thing/".concat(flattrCode);
    } else {
      throw new Error('flattrUsername/flattrCode is missing');
    }
  } // Create


  var image = 'https://img.shields.io/badge/flattr-donate-yellow.svg';
  var url = flattrURL;
  var alt = 'Flattr donate button';
  var title = 'Donate to this project using Flattr';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

flattr.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Paypal Badge */
function paypal(_ref22) {
  var paypalURL = _ref22.paypalURL,
      paypalButtonID = _ref22.paypalButtonID,
      paypalUsername = _ref22.paypalUsername;

  // Check
  if (!paypalURL) {
    if (paypalButtonID) {
      paypalURL = "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&amp;hosted_button_id=".concat(escape(paypalButtonID));
    } else if (paypalUsername) {
      paypalURL = "https://paypal.me/".concat(paypalUsername);
    } else {
      throw new Error('paypalURL, paypalButtonID, or paypalUsername is missing, at least one must exist');
    }
  } // Create


  var image = 'https://img.shields.io/badge/paypal-donate-yellow.svg';
  var url = paypalURL;
  var alt = 'PayPal donate button';
  var title = 'Donate to this project using Paypal';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

paypal.badgeCategory = 'funding';

/** Crypto Badge */
function crypto(_ref23) {
  var cryptoURL = _ref23.cryptoURL,
      bitcoinURL = _ref23.bitcoinURL;
  // Check
  var url = cryptoURL || bitcoinURL;
  if (!url) throw new Error('cryptoURL is missing'); // Create

  var image = 'https://img.shields.io/badge/crypto-donate-yellow.svg';
  var alt = 'crypto donate button';
  var title = 'Donate to this project using Cryptocurrency';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

crypto.badgeCategory = 'funding';
/** @deprecated */

function bitcoin(opts) {
  return crypto(opts);
}

bitcoin.badgeCategory = 'funding';

/** Wishlist Badge */
function wishlist(_ref24) {
  var wishlistURL = _ref24.wishlistURL;
  // Check
  if (!wishlistURL) throw new Error('wishlistURL is missing'); // Create

  var image = 'https://img.shields.io/badge/wishlist-donate-yellow.svg';
  var url = wishlistURL;
  var alt = 'Wishlist browse button';
  var title = 'Buy an item on our wishlist for us';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

wishlist.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Buy Me A Coffee Badge */
function buymeacoffee(_ref25) {
  var buymeacoffeeUsername = _ref25.buymeacoffeeUsername,
      buymeacoffeeURL = _ref25.buymeacoffeeURL;

  // Check
  if (!buymeacoffeeURL) {
    if (!buymeacoffeeUsername) throw new Error('buymeacoffeeUsername is missing');
    buymeacoffeeURL = "https://buymeacoffee.com/".concat(buymeacoffeeUsername);
  } // Create


  var image = 'https://img.shields.io/badge/buy%20me%20a%20coffee-donate-yellow.svg';
  var url = buymeacoffeeURL;
  var alt = 'Buy Me A Coffee donate button';
  var title = 'Donate to this project using Buy Me A Coffee';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

buymeacoffee.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Liberapay Badge */
function liberapay(_ref26) {
  var liberapayUsername = _ref26.liberapayUsername,
      liberapayURL = _ref26.liberapayURL;

  // Check
  if (!liberapayURL) {
    if (!liberapayUsername) throw new Error('liberapayUsername is missing');
    liberapayURL = "https://liberapay.com/".concat(liberapayUsername);
  } // Create


  var image = 'https://img.shields.io/badge/liberapay-donate-yellow.svg';
  var url = liberapayURL;
  var alt = 'Liberapay donate button';
  var title = 'Donate to this project using Liberapay';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

liberapay.badgeCategory = 'funding';
/** At least one of the properties must be provided */

/** Thanks App Badge */
function thanksapp(_ref27) {
  var npmPackageName = _ref27.npmPackageName,
      githubSlug = _ref27.githubSlug,
      thanksappUsername = _ref27.thanksappUsername,
      thanksappURL = _ref27.thanksappURL;

  // Check
  if (!thanksappURL) {
    if (thanksappUsername) {
      thanksappURL = "https://givethanks.app/u/".concat(thanksappUsername);
    } else if (npmPackageName) {
      thanksappURL = "https://givethanks.app/donate/npm/".concat(npmPackageName);
    } else if (githubSlug) {
      thanksappURL = "https://givethanks.app/donate/github/".concat(githubSlug);
    } else {
      throw new Error('at least one of these is required: thanksappUsername, npmPackageName, githubSlug');
    }
  } // Create


  var image = 'https://img.shields.io/badge/thanksapp-donate-yellow.svg';
  var url = thanksappURL;
  var alt = 'Thanks App donate button';
  var title = 'Donate to this project using Thanks App';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

thanksapp.badgeCategory = 'funding';
/** Boost Lab Badge */

function boostlab(_ref28) {
  var githubSlug = _ref28.githubSlug;
  // Check
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = 'https://img.shields.io/badge/boostlab-donate-yellow.svg';
  var url = "https://boost-lab.app/".concat(githubSlug);
  var alt = 'Boost Lab donate button';
  var title = 'Donate to this project using Boost Lab';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

boostlab.badgeCategory = 'funding'; // ====================================
// Social Badges

/** Slackin Script Badge */
function slackinscript(_ref29) {
  var slackinURL = _ref29.slackinURL;
  // Check
  if (!slackinURL) throw new Error('slackinURL is missing'); // Create

  return "<script async defer src=\"".concat(slackinURL, "/slackin.js\"></script>");
}

slackinscript.badgeCategory = 'social';
slackinscript.badgeScript = true;
/** Slackin Badge */

function slackin(_ref30) {
  var slackinURL = _ref30.slackinURL;
  // Check
  if (!slackinURL) throw new Error('slackinURL is missing'); // Create

  var image = "".concat(slackinURL, "/badge.svg");
  var url = slackinURL;
  var alt = 'Slack community badge';
  var title = "Join this project's slack community";
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

slackin.badgeCategory = 'social';

/**
 * Google Analytics Beacon Badge
 * https://github.com/igrigorik/ga-beacon
 */
function gabeacon(_ref31) {
  var gaTrackingID = _ref31.gaTrackingID,
      githubSlug = _ref31.githubSlug;
  // Check
  if (!gaTrackingID) throw new Error('gaTrackingID is missing');
  if (!githubSlug) throw new Error('githubSlug is missing'); // Create

  var image = "https://ga-beacon.appspot.com/".concat(gaTrackingID, "/").concat(githubSlug);
  var url = 'https://github.com/igrigorik/ga-beacon';
  var alt = 'Google Analytics beacon image';
  var title = 'Get Google Analytics for your project';
  return badge({
    image: image,
    alt: alt,
    url: url,
    title: title
  });
}

gabeacon.badgeCategory = 'social';
/** Google Plus One Button */

function googleplusone(_ref32) {
  var homepage = _ref32.homepage;
  // Check
  if (!homepage) throw new Error('homepage is missing'); // Create

  return "<span class=\"g-plusone\" data-size=\"medium\" data-href=\"".concat(homepage, "\"></span><script>(function() {var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true; po.src = '//apis.google.com/js/plusone.js'; var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);})();</script>");
}

googleplusone.badgeCategory = 'social';
googleplusone.badgeScript = true;
/** Reddit Submit Button */

function redditsubmit(_ref33) {
  var homepage = _ref33.homepage;
  // Check
  if (!homepage) throw new Error('homepage is missing'); // Create

  return "<script>reddit_url=\"".concat(homepage, "\"</script><script src=\"https://en.reddit.com/static/button/button1.js\"></script>");
}

redditsubmit.badgeCategory = 'social';
redditsubmit.badgeScript = true;
/** Hacker News Submit Button */

function hackernewssubmit(_ref34) {
  var homepage = _ref34.homepage;
  // Check
  if (!homepage) throw new Error('homepage is missing'); // Create

  return "<a href=\"https://news.ycombinator.com/submit\" class=\"hn-button\" data-url=\"".concat(homepage, "\" data-count=\"horizontal\">Vote on Hacker News</a><script>var HN=[];HN.factory=function(e){return function(){HN.push([e].concat(Array.prototype.slice.call(arguments,0)))};},HN.on=HN.factory(\"on\"),HN.once=HN.factory(\"once\"),HN.off=HN.factory(\"off\"),HN.emit=HN.factory(\"emit\"),HN.load=function(){var e=\"hn-button.js\";if(document.getElementById(e))return;var t=document.createElement(\"script\");t.id=e,t.src=\"https://hn-button.herokuapp.com/hn-button.js\";var n=document.getElementsByTagName(\"script\")[0];n.parentNode.insertBefore(t,n)},HN.load();</script>");
}

hackernewssubmit.badgeCategory = 'social';
hackernewssubmit.badgeScript = true;

/** Facebook Like Button */
function facebooklike(_ref35) {
  var homepage = _ref35.homepage,
      facebookApplicationID = _ref35.facebookApplicationID;
  // Prepare
  if (!homepage) throw new Error('homepage is missing');
  facebookApplicationID = facebookApplicationID || process.env.FACEBOOK_APPLICATION_ID;
  if (!facebookApplicationID) throw new Error('facebookApplicationID is missing'); // Return

  return "<iframe src=\"https://www.facebook.com/plugins/like.php?href=".concat(escape(homepage), "&amp;send=false&amp;layout=button_count&amp;width=450&amp;show_faces=false&amp;font&amp;colorscheme=light&amp;action=like&amp;height=21&amp;appId=").concat(escape(facebookApplicationID), "\" scrolling=\"no\" frameborder=\"0\" style=\"border:none; overflow:hidden; width:450px; height:21px;\" allowTransparency=\"true\"></iframe>");
}

facebooklike.badgeCategory = 'social';
facebooklike.badgeScript = true;

/** Facebook Follow Button */
function facebookfollow(_ref36) {
  var facebookUsername = _ref36.facebookUsername,
      facebookApplicationID = _ref36.facebookApplicationID;
  // Prepare
  if (!facebookUsername) throw new Error('facebookUsername is missing');
  facebookApplicationID = facebookApplicationID || process.env.FACEBOOK_APPLICATION_ID;
  if (!facebookApplicationID) throw new Error('facebookApplicationID is missing'); // Return

  return "<iframe src=\"https://www.facebook.com/plugins/follow.php?href=https%3A%2F%2Fwww.facebook.com%2F".concat(escape(facebookUsername), "&amp;layout=button_count&amp;show_faces=false&amp;colorscheme=light&amp;font&amp;width=450&amp;appId=").concat(escape(facebookApplicationID), "\" scrolling=\"no\" frameborder=\"0\" style=\"border:none; overflow:hidden; width:450px; height: 20px;\" allowTransparency=\"true\"></iframe>");
}

facebookfollow.badgeCategory = 'social';
facebookfollow.badgeScript = true;
/** Twitter Tweet Button */

function twittertweet(_ref37) {
  var twitterUsername = _ref37.twitterUsername;
  // Prepare
  if (!twitterUsername) throw new Error('twitterUsername is missing'); // Return

  return "<a href=\"https://twitter.com/share\" class=\"twitter-share-button\" data-via=\"".concat(twitterUsername, "\" data-related=\"").concat(twitterUsername, "\">Tweet</a><script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"https://platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>");
}

twittertweet.badgeCategory = 'social';
twittertweet.badgeScript = true;
/** Twitter Follow Button */

function twitterfollow(_ref38) {
  var twitterUsername = _ref38.twitterUsername;
  // Prepare
  if (!twitterUsername) throw new Error('twitterUsername is missing'); // Return

  return "<a href=\"https://twitter.com/".concat(escape(twitterUsername), "\" class=\"twitter-follow-button\" data-show-count=\"false\">Follow @").concat(twitterUsername, "</a><script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0];if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=\"https://platform.twitter.com/widgets.js\";fjs.parentNode.insertBefore(js,fjs);}}(document,\"script\",\"twitter-wjs\");</script>");
}

twitterfollow.badgeCategory = 'social';
twitterfollow.badgeScript = true;
/** Github Follow Button */

function githubfollow(_ref39) {
  var githubUsername = _ref39.githubUsername;
  // Prepare
  if (!githubUsername) throw new Error('githubUsername is missing'); // Return

  return "<iframe src=\"https://ghbtns.com/github-btn.html?user=".concat(escape(githubUsername), "&amp;type=follow&amp;count=true\" allowtransparency=\"true\" frameborder=\"0\" scrolling=\"0\" width=\"165\" height=\"20\"></iframe>");
}

githubfollow.badgeCategory = 'social';
githubfollow.badgeScript = true;
/** GitHub Star Button */

function githubstar(_ref40) {
  var githubSlug = _ref40.githubSlug;
  // Prepare
  if (!githubSlug) throw new Error('githubSlug is missing');
  var split = githubSlug.split('/');
  var githubUsername = split[0];
  var githubRepository = split[1];
  if (!githubUsername || !githubRepository) throw new Error('githubSlug is invalid'); // Return

  return "<iframe src=\"https://ghbtns.com/github-btn.html?user=".concat(escape(githubUsername), "&amp;repo=").concat(escape(githubRepository), "&amp;type=watch&amp;count=true\" allowtransparency=\"true\" frameborder=\"0\" scrolling=\"0\" width=\"110\" height=\"20\"></iframe>");
}

githubstar.badgeCategory = 'social';
githubstar.badgeScript = true;

/** Quora Follow Button */
function quorafollow(_ref41) {
  var quoraUsername = _ref41.quoraUsername,
      quoraRealname = _ref41.quoraRealname,
      quoraCode = _ref41.quoraCode;
  // Prepare
  if (!quoraUsername) throw new Error('quoraUsername is missing');
  quoraRealname = quoraRealname || quoraUsername.replace(/-/g, ' ');
  quoraCode = quoraCode || '7N31XJs'; // Return

  return "\n\t\t<span data-name=\"".concat(quoraUsername, "\">\n\t\t\tFollow <a href=\"http://www.quora.com/").concat(quoraUsername, "\">").concat(quoraRealname, "</a> on <a href=\"http://www.quora.com\">Quora</a>\n\t\t\t<script src=\"https://www.quora.com/widgets/follow?embed_code=").concat(escape(quoraCode), "\"></script>\n\t\t</span>").replace(/\n\s*/g, '');
}

quorafollow.badgeCategory = 'social';
quorafollow.badgeScript = true;